import numpy as np
import warnings
warnings.filterwarnings("ignore") #suppress warnings
import matplotlib.pyplot as plt
from sklearn.model_selection import train_test_split
from sklearn.preprocessing import StandardScaler

import csv
import pandas as pd

headers = ['timestamp', 'fridge_load', 'freezer1_load', 'freezer2_load', 'washing_machine_load', 'dishwasher_load', 'computer_load', 'television_site_load', 'electric_heater_load', 'aggregate_load', 'washer_dryer_load'
 ]

smarthome_df = pd.read_csv('/content/sample_data/REFIT_house1_reordered_classification.csv', sep=' ', names=headers)

smarthome_df.dtypes

smarthome_df['timestamp'] = pd.to_datetime(smarthome_df['timestamp'])
smarthome_df.info()

X = smarthome_df.drop(columns=['washer_dryer_load'])

y_label = smarthome_df['washer_dryer_load'].values

Xtrain, Xtest, ytrain, ytest = train_test_split(X, y_label, test_size=0.2, random_state=2)

sc = StandardScaler()
sc.fit(Xtrain)
Xtrain = sc.transform(Xtrain)
Xtest = sc.transform(Xtest)

print(f"Shape of train set is {Xtrain.shape}")
print(f"Shape of test set is {Xtest.shape}")
print(f"Shape of train label is {ytrain.shape}")
print(f"Shape of test labels is {ytest.shape}")

from sklearn.neural_network import MLPClassifier
from sklearn.metrics import accuracy_score

sknet = MLPClassifier(hidden_layer_sizes=(8), learning_rate_init=0.01, max_iter=100)

sknet.fit(Xtrain, ytrain)
preds_train = sknet.predict(Xtrain)
preds_test = sknet.predict(Xtest)