import numpy as np
import warnings
warnings.filterwarnings("ignore") #suppress warnings
import matplotlib.pyplot as plt
from sklearn.cluster import KMeans

import csv
import math
import pandas as pd

def datetime_to_float(d):
    return d.timestamp()

headers = ['timestamp', 'fridge_load', 'freezer1_load', 'freezer2_load', 'washing_machine_load', 'dishwasher_load', 'computer_load', 'television_site_load', 'electric_heater_load', 'aggregate_load', 'washer_dryer_load'
 ]

smarthome_df = pd.read_csv('/content/sample_data/REFIT_house1_reordered_clustering.csv', sep=',', names=headers)

smarthome_df.dtypes

smarthome_df.head()

smarthome_df['timestamp'] = pd.to_datetime(smarthome_df['timestamp'])

smarthome_df['month'] = smarthome_df['timestamp'].dt.month
smarthome_df['Day_of_week'] = smarthome_df['timestamp'].dt.dayofweek
smarthome_df['hour'] = smarthome_df['timestamp'].dt.hour
smarthome_df['minute'] = smarthome_df['timestamp'].dt.minute

smarthome_df.dtypes

smarthome_df.fillna(0)

X = smarthome_df.drop(columns=['washer_dryer_load'])

X = smarthome_df.drop(columns=['timestamp'])

X.dtypes

X.fillna(X.mean())

X.head()

kmeans = KMeans(n_clusters=2, random_state=0).fit(X)