from sklearn.cluster import KMeans
from py4j.java_gateway import JavaGateway
import pandas as pd
from collections import OrderedDict
import time

HOST = '127.0.0.1'
PORT = 65432

devices = OrderedDict({'192.168.1.1': 'fridge_load', '192.168.1.2': 'freezer1_load'})


class DAServer:
    def __init__(self):
        self.algorithm = KMeans(n_clusters=2)

    def train(self, data):
        self.algorithm.fit(data)

    def predict(self, data):
        return self.algorithm.predict(data)


if __name__ == '__main__':
    da = DAServer()
    initial_data = 'PATH_TO_INITIAL_DATASET'
    initial_data = pd.read_csv(initial_data)
    initial_data.drop(initial_data.columns[-1])
    da.train(initial_data)

    gateway = JavaGateway()
    java_object = gateway.jvm.Server()

    while True:
        ip, code = java_object.query()

        data = [None for _ in range(2)]
        device = devices.get(ip)
        # TODO: adding time constraint to construct the data
        if device == 'fridge_load':
            data[0] = code
        elif device == 'freezer1_load':
            data[1] = code
        cluster = da.predict(data)

